#include <propeller.h>
#include "ws2812.h"

/* led chain */
#define LED_PIN     13
#define LED_COUNT   4

int main(void)
{
    
    uint32_t ledColors[LED_COUNT];  // 4 Parallax WS2812B Fun Boards
    ws2812_t driver;
    
    // load the LED driver
    if (ws2812_init(&driver) < 0)
        return 1;
        
    // start with the outer two LEDs green and the inner two red
    ledColors[0] = COLOR_GREEN;
    ledColors[1] = COLOR_RED;
    ledColors[2] = COLOR_RED;
    ledColors[3] = COLOR_GREEN;
    
    // animate the LED colors
    for (;;) {
    
        // swap the inner and outer colors
        ledColors[0] = ledColors[1];
        ledColors[1] = ledColors[3];
        ledColors[2] = ledColors[3];
        ledColors[3] = ledColors[0];
    
        // update the LED chain
        ws2812_refresh(&driver, LED_PIN, ledColors, LED_COUNT);
            
        // delay between frames
        waitcnt(CNT + CLKFREQ);
    }
           
    return 0;
}
